/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package MacielPereira;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;


public class EchoServer {

    private static boolean gravar(String file, String inputLine) {
        try {
            OutputStream os = new FileOutputStream(file, true);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            BufferedWriter bw = new BufferedWriter(osw);
            bw.write("\nInfo: " + inputLine);
            bw.close();
            return true;
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
            return false;

        }
    }

    private static void lerDoDisco(String meuarquivotxt, String string) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    
    public void lerDoDisco() {
        try {
            InputStream is = new FileInputStream("meuarquivo.txt");
            //InputStream is = System.in;
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String s = br.readLine(); // primeira linha
            while (s != null) {
                System.out.println(s);
                s = br.readLine();
            }
            br.close();            
        }catch(java.io.FileNotFoundException FNE){
            System.out.println("Arquivos não encontrado!");
        }
        catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
        }
    }
    
    
    
    public static void main(String[] args) throws IOException {

        if (args.length != 1) {
            System.err.println("Usage: java EchoServer <port number>");
            System.exit(1);
        }

        int portNumber = Integer.parseInt(args[0]);

        try {
            ServerSocket serverSocket
                    = new ServerSocket(Integer.parseInt(args[0]));
            Socket clientSocket = serverSocket.accept();
            PrintWriter out
                    = new PrintWriter(clientSocket.getOutputStream(), true);
            BufferedReader in = new BufferedReader(
                    new InputStreamReader(clientSocket.getInputStream()));

            String inputLine;
            String[] buffer = new String[4];
            int i = 0;
            while ((inputLine = in.readLine()) != null) {
                out.println(inputLine);
                if (inputLine.equalsIgnoreCase("exit") || inputLine.equalsIgnoreCase("quit")) {
                    System.exit(0);
                } 

                if (!inputLine.equalsIgnoreCase("quit")
                        && !inputLine.equalsIgnoreCase("exit")
                        && !inputLine.equalsIgnoreCase("saveData")
                        && !inputLine.equalsIgnoreCase("cleanData")
                        && !inputLine.equalsIgnoreCase("showData")) {
                    buffer[i++] = inputLine.toString();
                    System.out.println("Bufferizando: \"" + inputLine.toString() + "\"");
                }

                if (i>= 4 || inputLine.equalsIgnoreCase("saveData")) {
                    for (int y = 0; y < buffer.length; y++) {
                        if (buffer[y] != null) {
                            //buffer[y] = inputLine.toString();
                            EchoServer.gravar("meuarquivo.txt", buffer[y]);

                        }
                    }
                }
                
                
                if (i>= 4 || inputLine.equalsIgnoreCase("showData")) {
                    for (int y = 0; y < buffer.length; y++) {
                        if (buffer[y] != null) {
                            //buffer[y] = inputLine.toString();
                            EchoServer.lerDoDisco("meuarquivo.txt", buffer[y]);

                        }
                    }
                }
                
            }
        } catch (IOException e) {
            System.out.println("Exception caught when trying to listen on port "
                    + portNumber + " or listening for a connection");
            System.out.println(e.getMessage());

        }
    }

}
